1 REMark Spinning disks by Per Witte - runs on SBASIC - GD2 only
2 :
3 rem V0.01 January 27th 2004
4 :
5 rem                     Variables
6 :
7 count% = 300:           rem Number of objects
8 acc = 1/20000:          rem Overall accelleration
9 cx = 50: cy = 50:       rem Centre
10 :
11 dim sx(count%):         rem Start position x
12 dim sy(count%):         rem Start position y
13 dim svx(count%):        rem Start velocity x
14 dim svy(count%):        rem Start velocity y
15 dim rd(count%):         rem Start radius
16 dim sax(count%):        rem Acceleration x
17 dim say(count%):        rem Acceleration y
18 dim col(count%):        rem Colour
19 dim ec(count%):         rem Eccentricity
20 dim ang(count%):        rem Angle
21 dim trn(count%):        rem Turn
22 dim fill%(count%):      rem Fill
23 :
24 pi2 = pi * 2
25 :
26 rem                     Init
27 :
28 dc = FOPEN("con_"): ERT dc
29 WINDOW#dc; SCR_XLIM(#dc), SCR_YLIM(#dc), 0, 0: CLS#dc
30 colour_24
31 RANDOMISE DATE
32 FOR i% = 0 TO count%: MakeObj(i%)
33 :
34 rem                     Program loop
35 REPeat main
36   Animate
37   IF CODE(INKEY$(#dc; 0)) = 27: EXIT main
38 END REPeat main
39 :
40 CLOSE#dc: QUIT
41 :
42 DEFine PROCedure MakeObj(n%)
43 a = RND * pi2
44 t% = RND * 25
45 svx(n%) = COS(a)
46 svy(n%) = SIN(a)
47 svx(n%) = svx(n%) + t% * sax(n%)
48 svy(n%) = svy(n%) + t% * say(n%)
49 sx(n%) = cx + svx(n%) * t% +.5 * sax(n%) * t% * t%
50 sy(n%) = cy + svy(n%) * t% +.5 * say(n%) * t% * t%
51 sax(n%) = sax(n%) * rnd(1 to 100)
52 say(n%) = say(n%) * rnd(0 to 100)
53 rep ll: rd(n%) = rnd / 5: if rd(n%) > 0: exit ll
54 ec(n%) = rnd(0 to 2)
55 ang(n%) = rnd(-90 to 90) * pi / 100
56 trn(n%) = rnd / rd(n%)
57 sel on rnd * 255: =1 to 25: fill%(n%) = 1: =remainder: fill%(n%) = 0
58 col(n%) = hex(hex$(RND * 255, 8) & hex$(rnd * 255, 8) & hex$(rnd * 255, 8))
59 END DEFine
60 :
61 DEFine PROCedure Animate
62 FOR i% = 0 TO count%
63  INK#dc; 0
64  fill#dc; fill%(i%)
65  circle#dc; sx(i%), sy(i%), rd(i%), ec(i%), ang(i%)
66  :
67  ang(i%) = ang(i%) + trn(i%)
68  sx(i%) = sx(i%) + svx(i%)
69  sy(i%) = sy(i%) + svy(i%)
70  svx(i%) = svx(i%) + sax(i%)
71  svy(i%) = svy(i%) + say(i%)
72  rd(i%) = rd(i%) + abs(svx(i%) + svy(i%)) / 34: rem Grow
73  IF sx(i%) < 0 OR sx(i%) > 100 OR sy(i%) < 0 OR sy(i%) > 100 THEN
74   MakeObj(i%)
75  ELSE
76   INK#dc; col(i%)
77   fill#dc; fill%(i%)
78   circle#dc;sx(i%), sy(i%), rd(i%), ec(i%), ang(i%)
79  END IF
80 END FOR i%
81 END DEFine
82 :
